/*
 * Copyright (c) 2024 Qualcomm Innovation Center, Inc. All rights reserved.
 * SPDX-License-Identifier: BSD-3-Clause-Clear
 */


/*===========================================================================
                                 INCLUDE FILES
===========================================================================*/
#ifndef UIE_H
#define UIE_H

#include "sec_comdef.h"
#include "seccommon.h"
/*===========================================================================
                      DEFINITIONS AND TYPE DECLARATIONS
===========================================================================*/

#define UIE_ENC_KEY_LADDER_CCM_n 13 // n from NIST 800-38C
#define UIE_ENC_KEY_LADDER_CCM_q 2  // q from NIST 800-38C
#define UIE_ENC_KEY_LADDER_CCM_Q 16 // Q from NIST 800-38C
#define UIE_ENC_KEY_LADDER_CCM_t 16 // t from NIST 800-38C
#define UIE_BASE_IV_LEN          16
#define UIE_DERIVED_IV_LEN       16
#define UIE_DERIVED_IV_OFFSET    16
#define UIE_KEY_LEN              16

/* @brief Enum for root encryption key type IDs */
typedef enum
{
  UIE_KEY_SRC_RTL_QC   =  0,
  UIE_KEY_SRC_OTP_OEM  =  1,
  UIE_KEY_SRC_OTP_QC   =  2
} uie_key_src_t;

typedef PACKED_STRUCT
{
  uint8 major;
  uint8 minor;
} uie_version_t;

#define UIE_CCM_B0_FLAGS           0x79
#define UIE_CCM_PAYLOAD_LEN_BYTE_0 0x00
#define UIE_CCM_PAYLOAD_LEN_BYTE_1 0x10
typedef PACKED_STRUCT
{
  uint8 flags;
  uint8 nonce[UIE_ENC_KEY_LADDER_CCM_n];
  uint8 payload_len[UIE_ENC_KEY_LADDER_CCM_q]; // Big endian uint16
} uie_ccm_b0_t;

#define UIE_ENC_PARAM_INFO_HDR_MAGIC_NUMBER 0x514d5349
typedef PACKED_STRUCT
{
  uint32        magic_number;
  uint8         num_enc_param_sec;
  uint8         _reserved[3];
  uint16        eps_offset;
  uie_version_t eps_ver;
  uint16        reserved[2];
} uie_enc_param_info_hdr_t;

#define UIE_ENC_PARAM_SEC_HDR_MAGIC_NUMBER 0x51554945
#define UIE_ENC_PARAM_SEC_SIZE             192
#define UIE_ENC_KEY_LADDER_ALGO_AES        1
#define UIE_ENC_KEY_LADDER_MODE_CCM        1
#define UIE_ROOT_KEY_TYPE_RLT_QC           0
#define UIE_ROOT_KEY_TYPE_OTP_OEM          1
#define UIE_ROOT_KEY_TYPE_OTP_QC           2
typedef PACKED_STRUCT
{
  uint32 magic_number;
  uint16 enc_param_sec_size;
  uint8  key_ladder_algo;
  uint8  key_ladder_mode;
  uint8  _reserved;
  uint8  root_key_type;
  uint16 root_key_info_id;
  uint32 _reserved2;
} uie_enc_param_sec_hdr_t;

#define UIE_L2_ADATA_LEN_BYTE_0 0x00
#define UIE_L2_ADATA_LEN_BYTE_1 0x20
#define UIE_KEY_LADDER_LEN      3
typedef PACKED_STRUCT
{
  uint8         adata_len[2]; // Big endian uint16
  uint8         _reserved[2];
  uie_version_t ver;
  uint8         key_ladder_len;
  uint8         _reserved2;
  uint32        image_id_bitmap;
  uint8         _reserved3[20];
} uie_l2_adata_t;

typedef PACKED_STRUCT
{
  uie_ccm_b0_t   b0;
  uie_l2_adata_t adata;
  uint8          encrypted_l2_key[UIE_ENC_KEY_LADDER_CCM_Q];
  uint8          mac[UIE_ENC_KEY_LADDER_CCM_t];
} uie_wrapped_l2_t;

#define UIE_L3_ADATA_LEN_BYTE_0    0x00
#define UIE_L3_ADATA_LEN_BYTE_1    0x20
#define UIE_IMAGE_ENC_ALGO_AES     1
#define UIE_IMAGE_ENC_MODE_CBC_CS2 1
#define UIE_SEGMENT_BITMAP_BITS    128
#define UINT32_BITS                32
typedef PACKED_STRUCT
{
  uint8  adata_len[2]; // Big endian uint16
  uint8  _reserved[2];
  uint8  image_enc_algo;
  uint8  image_enc_mode;
  uint8  _reserved2[6];
  uint8  all_seg_encrypted;
  uint8  num_seg;
  uint16 _reserved3;
  uint32 segment_bitmap[UIE_SEGMENT_BITMAP_BITS/UINT32_BITS];
} uie_l3_adata_t;

typedef PACKED_STRUCT
{
  uie_ccm_b0_t   b0;
  uie_l3_adata_t adata;
  uint8          encrypted_l3_key[UIE_ENC_KEY_LADDER_CCM_Q];
  uint8          mac[UIE_ENC_KEY_LADDER_CCM_t];
} uie_wrapped_l3_t;

typedef PACKED_STRUCT
{
  uie_enc_param_sec_hdr_t hdr;
  uie_wrapped_l2_t        wrapped_l2;
  uie_wrapped_l3_t        wrapped_l3;
  uint8                   base_iv[UIE_BASE_IV_LEN];
} uie_enc_param_sec_t;

typedef PACKED_STRUCT
{
  uie_enc_param_info_hdr_t info_hdr;
  uie_enc_param_sec_t      eps;
} uie_header_t;

typedef struct uie_ctx_priv // Internal implementation of uie_ctx
{
  uie_version_t library_version;          // Generated by the library
  uint8         l3_key_eps[UIE_KEY_LEN]; // Derived by EPS2 key unwrap
  uie_header_t  hdr;                      // Local copy of image header
  sec_img_auth_id_type img_id;
}uie_ctx;


#define UIE_LIBRARY_VERSION_MAJOR 1
#define UIE_LIBRARY_VERSION_MINOR 0

/* Error codes */
#define UIE_STATUS_SUCCESS       0
#define UIE_STATUS_FAILURE       1 
#define UIE_STATUS_INVALID_PARAM 2 
#define UIE_STATUS_DECRYPT_FAIL  3 
#define UIE_STATUS_KEYWRAP_FAIL  4 
#define UIE_STATUS_HASH_FAIL     5 
#define UIE_STATUS_KEY_READ_FAIL 6 
#define UIE_STATUS_INCORRECT_NUMBER_OF_EPS_SECTIONS 7
#define UIE_STATUS_INCORRECT_VERSION 8
#define UIE_STATUS_INCORRECT_EPS_OFFSET 9
#define UIE_ENC_PARAM_SEC_ADATA_VERSION_MISMATCH 0xA 
#define UIE_ENC_PARAM_SEC_ADATA_KEY_LEN_MISMATCH 0xB 
#define UIE_IMAGE_ENC_INVALID_L3_LEN_BYTE_0 0xC 
#define UIE_IMAGE_ENC_INVALID_L3_LEN_BYTE_1 0xD 
#define UIE_ENC_PARAM_SEC_MAGIC_MISTMATCH 0xE 
#define UIE_IMAGE_ENC_INVALID_L3_MODE 0xF
#define UIE_ENC_PARAM_SEC_ADATA_IMAGE_ID_NOT_ALLOWED 0x10
#define UIE_IMAGE_ENC_INVALID_L3_ALGO 0x11
#define UIE_ENC_PARAM_SEC_ADATA_BYTE_0_MISMATCH 0x12
#define UIE_ENC_PARAM_SEC_ADATA_BYTE_1_MISMATCH 0x13
#define UIE_ENC_PARAM_SEC_INFO_ID_MISMATCH 0x14
#define UIE_ENC_PARAM_SEC_KEY_TYPE_MISMATCH 0x15
#define UIE_ENC_PARAM_SEC_MODE_MISMATCH 0x16
#define UIE_ENC_PARAM_SEC_SIZE_MISMATCH 0x17
#define UIE_ENC_PARAM_SEC_ALGO_MISMATCH 0x18
#define UIE_ENC_STATUS_IMAGE_ENCRYPTION_DISABLED 0x19
#define UIE_STATUS_IMAGE_ENCRYPTION_DISABLED 0x1A
#define UIE_STATUS_INVALID_ENCRYPTION_KEY_ID 0x1B
#define UIE_INVALID_IMAGE_ID 0x1C
#define UIE_STATUS_HW_GET_ROT_INFO_FAILURE 0x1D
#define UIE_STATUS_HW_GET_HASH_IN_FUSE_FAILURE 0x1E
#define UIE_STATUS_VALIDATE_ZERO_ERROR 0x1F
#define UIE_STATUS_INCORRECT_INFO_HDR_MAGIC_NUMBER 0x20
#define UIE_IMAGE_ENC_ALL_SEGMENTS_NOT_ENCRYPTED 0x21
#define UIE_STATUS_DECRYPT_L2_FAIL 0x22
#define UIE_STATUS_DECRYPT_L3_FAIL 0x23
#define UIE_STATUS_ENCRYPTION_NOT_ENABLED 0x24
#define UIE_STATUS_CCM_B0_FLAGS_VALIDATION_FAILED 0x25
#define UIE_STATUS_CCM_B0_PAYLOAD_LEN_BYTE_0_FAILED 0x26
#define UIE_STATUS_CCM_B0_PAYLOAD_LEN_BYTE_1_FAILED 0x27

/*===========================================================================
                             FUNCTION PROTOTYPES
===========================================================================*/

/**
 * @brief Sets up UIE operation. For proper memory management,
 *        uie_deinit() should be called at end of life.
 *        Unwrapping the keys in this function.
 *
 * @param[in]  uie_img_ctx     The context we work on
 * @param[in]  img_id          The image to be decrypted 
 * @param[in]  header_address  The address of the encrypted image parameter section
 * @param[in]  crypto_ftbl     The cryptographic drivers
 *
 * @return - 0 on success, non-zero on failure.
 */
/* TBD: Check the Encryption enablement fuse in this library */
uint32 uie_init(uie_ctx *uie_img_ctx,
                sec_img_auth_id_type img_id,
                void *header_address,
                crypto_ftbl_type * crypto_ftbl);

/**
 * @brief Decrypts a segment in-place and verifies its validity.
 *
 * @param[in]  uie_img_ctx     The context we work on
 * @param[in]  img_id          The image to be decrypted 
 * @param[in]  segment_id      The segment to check
 * @param[in]  segment_address The address of the segment to decrypt
 * @param[in]  segment_length  The byte length of the segment
 * @param[out] digest          The optional SHA256 hashsum; a non-NULL
 *                             input address will result in a digest output
 * @param[in]  crypto_ftbl     The cryptographic drivers
 *
 * @return - 0 on success, non-zero on failure.
 */
uint32 uie_decrypt_segment(uie_ctx *uie_img_ctx,
                           sec_img_auth_id_type img_id, uint8 segment_id,
                           void *segment_address, uint32 segment_length,
                           crypto_ftbl_type * crypto_ftbl,
                           uint8 *digest);

/**
 * @brief Tears down UIE operation.
 *
 * @param[in]  img_id          The image to be decrypted 
 * @param[in]  uie_img_ctx     The context to work on
 */
void uie_deinit(sec_img_auth_id_type img_id, uie_ctx *uie_img_ctx);

/**
 * @brief return the byte size of uie param
 *
 */
uint32 uie_get_param_size(void);

#endif /* UIE_H */
